<!-- 
 * @Description: 表单
 * @Author: huguodong 
 * @Date: 2023-12-15 15:45:28
!-->
<template>
  <div>
    <form-container v-model="visible" :title="`${orgProps.opt}监控`" form-size="600px">
      <el-form
        ref="liveFormRef"
        :rules="rules"
        :disabled="orgProps.disabled"
        :model="orgProps.record"
        :hide-required-asterisk="orgProps.disabled"
        label-width="auto"
        label-suffix=" :"
      >
        <s-form-item label="摄像头名称" prop="sensorName">
          <s-input v-model="orgProps.record.sensorName"></s-input>
        </s-form-item>
        <s-form-item label="所属学校" prop="fieldName">
          <org-selector v-model:org-value="orgProps.record.fieldName" :org-tree-api="bizOrgApi.tree" :show-all="false" />
        </s-form-item>
        <s-form-item label="设备IP" prop="directUrlIp">
          <s-input v-model="orgProps.record.directUrlIp" clearable></s-input>
        </s-form-item>
        <s-form-item label="分辨率(width)" prop="resWidth">
          <s-input v-model="orgProps.record.resWidth" clearable></s-input>
        </s-form-item>
        <s-form-item label="分辨率(height)" prop="resHeight">
          <s-input v-model="orgProps.record.resHeight" clearable></s-input>
        </s-form-item>
      </el-form>
      <template #footer>
        <el-button @click="onClose"> 取消 </el-button>
        <el-button v-show="!orgProps.disabled" type="primary" @click="handleSubmit"> 确定 </el-button>
      </template>
    </form-container>
  </div>
</template>

<script setup lang="ts">
import { SysOrg, SysUser, bizOrgApi, bizPositionApi, sysRoleApi, bizUserApi } from "@/api";
import { FormOptEnum, SysDictEnum } from "@/enums";
import { required } from "@/utils/formRules";
import { FormInstance } from "element-plus";
import { useDictStore } from "@/stores/modules";

const visible = ref(false); //是否显示表单
const dictStore = useDictStore(); //字典仓库

// 通用状态选项
const statusOptions = dictStore.getDictList(SysDictEnum.COMMON_STATUS);

// 表单参数
const orgProps = reactive<FormProps.Base<any>>({
  opt: FormOptEnum.ADD,
  record: {},
  disabled: false
});

// 表单验证规则
const rules = reactive({
  sensorName: [required("请输入摄像头名称")],
  fieldName: [required("请选择所属学校")],
  directUrlIp: [required("请选择设备IP")],
  resWidth: [required("请输入分辨率(width)")],
  resHeight: [required("请输入分辨率(height)")]
});

/**
 * 打开表单
 * @param props 表单参数
 */
function onOpen(props: FormProps.Base<SysOrg.SysOrgInfo>) {
  Object.assign(orgProps, props); //合并参数
  if (props.opt == FormOptEnum.ADD) {
    //如果是新增,设置默认值
    // orgProps.record.sortCode = 99;
    // orgProps.record.status = statusOptions[0].value;
  }
  visible.value = true; //显示表单
  if (props.record.id) {
    orgProps.record = props.record;
    //如果传了id，就去请求api获取record
    return;
    bizOrgApi.detail({ id: props.record.id }).then(res => {
      orgProps.record = res.data;
    });
  }
}

// 提交数据（新增/编辑）
const liveFormRef = ref<FormInstance>();
/** 提交表单 */
async function handleSubmit() {
  liveFormRef.value?.validate(async valid => {
    if (!valid) return; //表单验证失败
    console.log(orgProps);
    return;
    //提交表单
    await bizOrgApi
      .submitForm(orgProps.record, orgProps.record.id != undefined)
      .then(() => {
        orgProps.successful!(); //调用父组件的successful方法
      })
      .finally(() => {
        onClose();
      });
  });
}

/** 关闭表单*/
function onClose() {
  visible.value = false;
}

// 暴露给父组件的方法
defineExpose({
  onOpen
});
</script>

<style lang="scss" scoped></style>
